<template>
  <v-app class="diseaseRecommendation">
    <div class="diseaseRecommendation__title">
      <h1>Рекомендации по услугам</h1>
    </div>

    <!--Поиск болезни-->
    <v-text-field class="diseaseRecommendation__search" v-model="search" append-icon="mdi-magnify" label="Поиск.." single-line
                  hide-details></v-text-field>

    <v-data-table
        :headers="headersService"
        :items="diseaseRecommendationService"
        :search="search"
        class="diseaseRecommendation__table"
    >
<!--      <template v-slot:top>-->
<!--        <v-toolbar flat>-->
<!--          <v-toolbar-title>Рекомендации по услугам</v-toolbar-title>-->
<!--          <v-spacer></v-spacer>-->
<!--          <v-spacer></v-spacer>-->
<!--          <v-dialog v-model="dialog" max-width="500px">-->
<!--            <template v-slot:activator="{ on, attrs }">-->
<!--              <v-btn color="primary" dark class="mb-2" v-bind="attrs" v-on="on" @click="loadPage">Добавить рекомендацию по услугам</v-btn>-->
<!--            </template>-->

<!--            &lt;!&ndash;Добавление рекомендации по услугам&ndash;&gt;-->
<!--            <v-card>-->
<!--              <v-card-title>-->
<!--                <span class="text-h5">{{ formTitle }}</span>-->
<!--              </v-card-title>-->

<!--              <v-card-text>-->
<!--                <v-container>-->
<!--                  <v-row>-->
<!--                    <v-col cols="12" sm="6" md="12">-->
<!--                      <v-overflow-btn v-model="editedItem.diseaseName" :items="diseases" item-value="id" item-text="name" label="Заболевание"/>-->
<!--                    </v-col>-->
<!--                    <v-col cols="12" sm="6" md="12">-->
<!--                      <v-overflow-btn v-model="editedItem.recommendService" :items="services" item-value="id" item-text="name" label="Услуга"/>-->
<!--                    </v-col>-->
<!--                  </v-row>-->
<!--                </v-container>-->
<!--              </v-card-text>-->

<!--              <v-card-actions>-->
<!--                <v-spacer></v-spacer>-->
<!--                <v-btn color="blue darken-1" text @click="close">Закрыть</v-btn>-->
<!--                <v-btn color="blue darken-1" text @click="save">Сохранить</v-btn>-->
<!--              </v-card-actions>-->
<!--            </v-card>-->
<!--          </v-dialog>-->

<!--          &lt;!&ndash;Удаление записи&ndash;&gt;-->
<!--          <v-dialog v-model="dialogDelete" max-width="510px">-->
<!--            <v-card>-->
<!--              <v-card-title class="text-h5">Вы уверены что хотите удалить запись?</v-card-title>-->
<!--              <v-card-actions>-->
<!--                <v-spacer></v-spacer>-->
<!--                <v-btn color="blue darken-1" text @click="closeDelete">Закрыть</v-btn>-->
<!--                <v-btn color="blue darken-1" text @click="deleteItemConfirm">OK</v-btn>-->
<!--                <v-spacer></v-spacer>-->
<!--              </v-card-actions>-->
<!--            </v-card>-->
<!--          </v-dialog>-->
<!--        </v-toolbar>-->
<!--      </template>-->

      <!--Иконки с действиями-->
<!--      <template v-slot:item.actions="{ item }">-->
<!--        <v-icon small class="mr-2" @click="editItem(item)"> mdi-pencil</v-icon>-->
<!--        <v-icon small @click="deleteItem(item)">mdi-delete</v-icon>-->
<!--      </template>-->
    </v-data-table>
  </v-app>
</template>

<script>
import {
  mdiPencil,
  mdiDelete,
} from "@mdi/js"
import axios from "axios";

export default {
  name: "DiseaseRecommendation",
  data() {
    return {
      icons: {
        mdiPencil,
        mdiDelete,
      },

      editedIndex: -1,
      editedId: -1,
      dialog: false,
      dialogDelete: false,
      search: '',

      diseaseRecommendationService: [],
      diseases: [],
      services: [],
      diseasesNames: [],
      recommendServicesNames: [],

      editedItem: {
        diseaseName: '',
        recommendService: ''
      },

      defaultItem: {
        diseaseName: '',
        recommendService: ''
      },

      headersService: [
        {
          text: 'Заболевание',
          value: 'disease.name',
          sortable: false
        },
        {
          text: 'Услуга',
          value: 'service.name',
          sortable: false
        },
        {
          text: 'Стоимость',
          value: 'service.price',
        },
        // {
        //   text: 'Действия',
        //   value: 'actions'
        // }
      ]
    }
  },

  computed: {
    formTitle() {
      return this.editedIndex === -1 ? 'Новая запись' : 'Редактировать запись'
    },
  },

  watch: {
    dialog(val) {
      val || this.close()
    },
    dialogDelete(val) {
      val || this.closeDelete()
    },
  },

  mounted() {
    this.fetchDiseaseRecommendation()
  },

  methods: {
    async fetchDiseaseRecommendation() {
      axios
          .get(this.$root.globalVar + '/recommendation_service')
          .then(response => {
            this.diseaseRecommendationService = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })

          axios
          .get(this.$root.globalVar + '/disease')
          .then(response => {
            this.diseasesNames = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })

      axios
          .get(this.$root.globalVar + '/service')
          .then(response => {
            this.recommendServicesNames = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
    },

    // async addDiseaseRecommendation(item) {
    //   axios.post(this.$root.globalVar + '/recommendation_service', {
    //     diseaseId: item.diseaseName,
    //     serviceId: item.recommendService
    //   })
    //       .then(response => this.diseaseRecommendationService.push(response.data))
    //       .catch(error => {
    //         console.log(error)
    //         alert('Ошибка! Подробности: введите данные в верном формате.')
    //       })
    // },
    //
    // async updateDiseaseRecommendation(item) {
    //   axios
    //       .put(this.$root.globalVar + '/recommendation_service/' + item.id, {
    //         diseaseId: item.diseaseName,
    //         serviceId: item.recommendService
    //       })
    //       .then(Object.assign(this.diseaseRecommendationService[this.editedIndex], item))
    //       .catch(error => {
    //         console.log(error)
    //         alert('Ошибка! Подробности: введите данные в верном формате.')
    //       })
    // },
    //
    // async deleteDiseaseRecommendation(item) {
    //   axios
    //       .delete(this.$root.globalVar + '/recommendation_service/' + item.id)
    //       .catch(error => {
    //         console.log(error)
    //       })
    //   this.diseaseRecommendationService.splice(this.editedIndex, 1)
    // },

    // loadPage() {
    //   this.diseasesNames.forEach(disease => this.diseases.push(disease))
    //   this.recommendServicesNames.forEach(service => this.services.push(service))
    // },

    // editItem(item) {
    //   this.editedIndex = this.diseaseRecommendationService.indexOf(item)
    //   this.editedId = item.id
    //   this.editedItem = Object.assign({}, item)
    //   this.dialog = true
    // },
    //
    // deleteItem(item) {
    //   this.editedIndex = this.diseaseRecommendationService.indexOf(item)
    //   this.editedId = item.id
    //   this.editedItem = Object.assign({}, item)
    //   this.dialogDelete = true
    // },
    //
    // deleteItemConfirm() {
    //   this.deleteDiseaseRecommendation(this.editedItem)
    //   this.closeDelete()
    // },

    // close() {
    //   this.dialog = false
    //   this.$nextTick(() => {
    //     this.editedItem = Object.assign({}, this.defaultItem)
    //     this.editedIndex = -1
    //     this.editedId = -1
    //   })
    // },
    //
    // closeDelete() {
    //   this.dialogDelete = false
    //   this.$nextTick(() => {
    //     this.editedItem = Object.assign({}, this.defaultItem)
    //     this.editedIndex = -1
    //     this.editedId = -1
    //   })
    // },
    //
    // save() {
    //   if (this.editedItem.diseaseName === '' || this.editedItem.recommendService === '') {
    //     alert('Ошибка! Подробности: введите данные.')
    //     throw new Error("Ошибка! Подробности: введите данные.");
    //   }
    //
    //   if (this.editedIndex > -1) {
    //     this.updateDiseaseRecommendation(this.editedItem, this.editedIndex)
    //   } else {
    //     this.addDiseaseRecommendation(this.editedItem)
    //   }
    //   this.close()
    // },
  }

}
</script>

<style lang="scss" scoped>
.diseaseRecommendation {
  &__title {
    text-align: center;
    margin: 60px 0 30px 0;
  }

  &__search {
    width: 50%;
    margin: 0 auto;
  }

  &__table {
    width: 70%;
    margin: 0 auto;
  }
}

.v-text-field {
  flex: 0.2 0 !important;
  margin-top: 30px;
}
</style>